package com.kafka.producer.resource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.common.pojos.User;

/**
 * Kafka Controller used to produce the User data to the consumer application.
 * @author rjosula
 *
 */
@RestController
@RequestMapping("kafka")
@PropertySource("appConfig.properties")
public class UserResource {

    @Autowired
    private KafkaTemplate<String, User> kafkaTemplate;

    @Value("${kafka.producer.topic.name}")
    private String TOPIC;

    @RequestMapping(value = "/publish", method = RequestMethod.POST)
    public User post(@RequestBody User user) {

        kafkaTemplate.send(TOPIC, user);

        return user;
    }
}
